﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Telerik.OpenAccess;

namespace ConsoleApplication43
{
    class Program
    {
        static void Main(string[] args)
        {
            new TestClass<RegionServerSideAutoinc>().Test();
            new TestClass<RegionClientSideHighLow>().Test();
            try
            {
                new TestClass<RegionClientSideID>().Test();
            }
            catch (Exception e)
            {
                Console.WriteLine(e.ToString());
            }
        }
    }

    class TestClass<T> where T:new()
    {
        internal void Test()
        {
            using (var scope1 = GetNewScope())
            {
                using (var scope2 = GetNewScope())
                {
                    scope1.Add(new T());
                    scope2.Add(new T());
                    scope1.Transaction.Commit();
                    scope2.Transaction.Commit();
                }
            }
        }

        internal void TestTryGetId1()
        {
            using (var scope1 = GetNewScope())
            {
                using (var scope2 = GetNewScope())
                {
                    var t1 = new T();
                    var t2 = new T();
                    scope1.Add(t1);
                    scope2.Add(t2);
                    scope1.Transaction.Commit();
                    scope2.Transaction.Commit();
                }
            }
        }


        private IObjectScope GetNewScope()
        {
            var db = Database.Get("DatabaseConnection1");
            var scope = db.GetObjectScope();
            scope.Transaction.Begin();
            return scope;
        }
    }


    [Telerik.OpenAccess.Persistent(IdentityField = "id")]
    class RegionClientSideID
    {
        private int id;
        private string name;

        public int Id
        {
            get
            {
                return id;
            }
            set
            {
                id = value;
            }
        }
        public string Name
        {
            get
            {
                return name;
            }
            set
            {
                name = value;
            }
        }
    }
    [Telerik.OpenAccess.Persistent(IdentityField = "id")]
    class RegionClientSideHighLow
    {
        private int id;
        private string name;

        public int Id
        {
            get
            {
                return id;
            }
            set
            {
                id = value;
            }
        }
        public string Name
        {
            get
            {
                return name;
            }
            set
            {
                name = value;
            }
        }
    }
    [Telerik.OpenAccess.Persistent(IdentityField = "id")]
    class RegionServerSideAutoinc
    {
        private int id;
        private string name;

        public int Id
        {
            get
            {
                return id;
            }
            set
            {
                id = value;
            }
        }
        public string Name
        {
            get
            {
                return name;
            }
            set
            {
                name = value;
            }
        }
    }
}
